{ include("common-cartago.asl") }

/* Benevolent agent with respect to the organisation. */

/* Initial beliefs and rules */
my_group("easssGr").
my_ssch("easssSch").
my_role("computer").


ngreetings(0).

/* Initial goals */
!setup.

// Initialisation Plans
 
+!setup : my_group(Gr) & my_ssch(Sch) & my_role(Role)
	<- 	.my_name(Me);
		joinRemoteWorkspace("server","localhost",WspID2);
		println("ready");	
	   	!enter_organization(Gr,Sch,Role).

-!setup 
	<- 	.wait(1000);
		!setup.
	
// Agent's organizational skills

+!enter_organization(Gr,Sch,Role)
	<- 	// Focusing on groupboard managing my group
		lookupArtifact(Gr,GId);
		+my_group_id(GId);
		focus(GId);
		adoptRole(Role)[artifact_id(GId)];
		// Focusing on schemeboard managing my social scheme
		lookupArtifact(Sch,SId);
		+my_scheme_id(SId);	
		focus(SId).

-!enter_organization(Gr,Sch)
	<- 	.println("Unable to enter the organization. Staying out").


// plans to handle obligations
+obligation(Ag,Norm,committed(Ag,Mission,Scheme),Deadline)
    : .my_name(Ag)
   <- .println("I am obliged to commit to ",Mission," on ",Scheme);
      commitMission(Mission)[artifact_name(Scheme)].
      
+obligation(Ag,Norm,achieved(Scheme,Goal,Ag),Deadline)
    : .my_name(Ag)
   <- .println("I am obliged to achieve goal ",Goal);
      !Goal[scheme(Scheme)];
      goalAchieved(Goal)[artifact_name(Scheme)].
      
+obligation(Ag,Norm,What,Deadline)  
   : .my_name(Ag)
   <- .print("I am obliged to ",What,", but I don't know what to do!").
	      
// Agent's skills

+!easss
	<-	.println("Achieving easss").
	
+!greet_for_ever
	<-	.my_name(Me);
	   	!greet_task("Do you want a gin tonic?").

-!greet_for_ever
	<- 	.wait(1000);
   		!greet_for_ever.

+!greet_task(Message) : ngreetings(N) & N<50
	<- 	.wait(math.random(500)+10);
		-+ngreetings(N+1);
	   	printMsg(Message);
	   	!greet_task(Message).	

+!compute
	<-  /* discovering and using the calcultor */
	    lookupArtifact("calculator",CalcId);
		computePi(100,Digits) [artifact_id(CalcId)];
		
		/* discovering and using the message console */
		lookupArtifact("msg-console",ConsoleId);
		printMsg(Digits)[artifact_id(ConsoleId)].
		
-!compute
	<- 	.wait(1000);
		!compute.
				
+!observe
 	<- lookupArtifact("msg-console",Id);
	   focus(Id).
	   
+numMsg(N) 
	<- println("new message: total number is ",N).

-!observe
	<- .wait(1000);
	   !observe.	
	   